// Code generated by protoc-gen-go-grpc. DO NOT EDIT.
// versions:
// - protoc-gen-go-grpc v1.3.0
// - protoc             v3.20.1
// source: internal/pkg/chord/proto/node.proto

package proto

import (
	context "context"
	grpc "google.golang.org/grpc"
	codes "google.golang.org/grpc/codes"
	status "google.golang.org/grpc/status"
)

// This is a compile-time assertion to ensure that this generated file
// is compatible with the grpc package it is being compiled against.
// Requires gRPC-Go v1.32.0 or later.
const _ = grpc.SupportPackageIsVersion7

const (
	Node_Successor_FullMethodName                 = "/chord.Node/Successor"
	Node_Predecessor_FullMethodName               = "/chord.Node/Predecessor"
	Node_FindSuccessor_FullMethodName             = "/chord.Node/FindSuccessor"
	Node_FindPredecessor_FullMethodName           = "/chord.Node/FindPredecessor"
	Node_ClosestPrecedingFinger_FullMethodName    = "/chord.Node/ClosestPrecedingFinger"
	Node_NotificationByPredecessor_FullMethodName = "/chord.Node/NotificationByPredecessor"
	Node_NotificationBySuccessor_FullMethodName   = "/chord.Node/NotificationBySuccessor"
	Node_CheckNode_FullMethodName                 = "/chord.Node/CheckNode"
	Node_SetReplicatedValue_FullMethodName        = "/chord.Node/SetReplicatedValue"
	Node_SetValue_FullMethodName                  = "/chord.Node/SetValue"
	Node_DelValue_FullMethodName                  = "/chord.Node/DelValue"
	Node_GetValue_FullMethodName                  = "/chord.Node/GetValue"
)

// NodeClient is the client API for Node service.
//
// For semantics around ctx use and closing/ending streaming RPCs, please refer to https://pkg.go.dev/google.golang.org/grpc/?tab=doc#ClientConn.NewStream.
type NodeClient interface {
	Successor(ctx context.Context, in *Void, opts ...grpc.CallOption) (*NodeInfo, error)
	Predecessor(ctx context.Context, in *Void, opts ...grpc.CallOption) (*NodeInfo, error)
	FindSuccessor(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeAndHopInfo, error)
	FindPredecessor(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeAndHopInfo, error)
	ClosestPrecedingFinger(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeInfo, error)
	NotificationByPredecessor(ctx context.Context, in *NodeInfo, opts ...grpc.CallOption) (*Void, error)
	NotificationBySuccessor(ctx context.Context, in *NodeInfo, opts ...grpc.CallOption) (*Void, error)
	CheckNode(ctx context.Context, in *NodeInfo, opts ...grpc.CallOption) (*Void, error)
	SetReplicatedValue(ctx context.Context, in *IdAndValue, opts ...grpc.CallOption) (*Void, error)
	SetValue(ctx context.Context, in *IdAndValue, opts ...grpc.CallOption) (*NodeAndHopInfo, error)
	DelValue(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeAndHopInfo, error)
	GetValue(ctx context.Context, in *Id, opts ...grpc.CallOption) (*ValueInfo, error)
}

type nodeClient struct {
	cc grpc.ClientConnInterface
}

func NewNodeClient(cc grpc.ClientConnInterface) NodeClient {
	return &nodeClient{cc}
}

func (c *nodeClient) Successor(ctx context.Context, in *Void, opts ...grpc.CallOption) (*NodeInfo, error) {
	out := new(NodeInfo)
	err := c.cc.Invoke(ctx, Node_Successor_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) Predecessor(ctx context.Context, in *Void, opts ...grpc.CallOption) (*NodeInfo, error) {
	out := new(NodeInfo)
	err := c.cc.Invoke(ctx, Node_Predecessor_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) FindSuccessor(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeAndHopInfo, error) {
	out := new(NodeAndHopInfo)
	err := c.cc.Invoke(ctx, Node_FindSuccessor_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) FindPredecessor(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeAndHopInfo, error) {
	out := new(NodeAndHopInfo)
	err := c.cc.Invoke(ctx, Node_FindPredecessor_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) ClosestPrecedingFinger(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeInfo, error) {
	out := new(NodeInfo)
	err := c.cc.Invoke(ctx, Node_ClosestPrecedingFinger_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) NotificationByPredecessor(ctx context.Context, in *NodeInfo, opts ...grpc.CallOption) (*Void, error) {
	out := new(Void)
	err := c.cc.Invoke(ctx, Node_NotificationByPredecessor_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) NotificationBySuccessor(ctx context.Context, in *NodeInfo, opts ...grpc.CallOption) (*Void, error) {
	out := new(Void)
	err := c.cc.Invoke(ctx, Node_NotificationBySuccessor_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) CheckNode(ctx context.Context, in *NodeInfo, opts ...grpc.CallOption) (*Void, error) {
	out := new(Void)
	err := c.cc.Invoke(ctx, Node_CheckNode_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) SetReplicatedValue(ctx context.Context, in *IdAndValue, opts ...grpc.CallOption) (*Void, error) {
	out := new(Void)
	err := c.cc.Invoke(ctx, Node_SetReplicatedValue_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) SetValue(ctx context.Context, in *IdAndValue, opts ...grpc.CallOption) (*NodeAndHopInfo, error) {
	out := new(NodeAndHopInfo)
	err := c.cc.Invoke(ctx, Node_SetValue_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) DelValue(ctx context.Context, in *Id, opts ...grpc.CallOption) (*NodeAndHopInfo, error) {
	out := new(NodeAndHopInfo)
	err := c.cc.Invoke(ctx, Node_DelValue_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *nodeClient) GetValue(ctx context.Context, in *Id, opts ...grpc.CallOption) (*ValueInfo, error) {
	out := new(ValueInfo)
	err := c.cc.Invoke(ctx, Node_GetValue_FullMethodName, in, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// NodeServer is the server API for Node service.
// All implementations must embed UnimplementedNodeServer
// for forward compatibility
type NodeServer interface {
	Successor(context.Context, *Void) (*NodeInfo, error)
	Predecessor(context.Context, *Void) (*NodeInfo, error)
	FindSuccessor(context.Context, *Id) (*NodeAndHopInfo, error)
	FindPredecessor(context.Context, *Id) (*NodeAndHopInfo, error)
	ClosestPrecedingFinger(context.Context, *Id) (*NodeInfo, error)
	NotificationByPredecessor(context.Context, *NodeInfo) (*Void, error)
	NotificationBySuccessor(context.Context, *NodeInfo) (*Void, error)
	CheckNode(context.Context, *NodeInfo) (*Void, error)
	SetReplicatedValue(context.Context, *IdAndValue) (*Void, error)
	SetValue(context.Context, *IdAndValue) (*NodeAndHopInfo, error)
	DelValue(context.Context, *Id) (*NodeAndHopInfo, error)
	GetValue(context.Context, *Id) (*ValueInfo, error)
	mustEmbedUnimplementedNodeServer()
}

// UnimplementedNodeServer must be embedded to have forward compatible implementations.
type UnimplementedNodeServer struct {
}

func (UnimplementedNodeServer) Successor(context.Context, *Void) (*NodeInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Successor not implemented")
}
func (UnimplementedNodeServer) Predecessor(context.Context, *Void) (*NodeInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method Predecessor not implemented")
}
func (UnimplementedNodeServer) FindSuccessor(context.Context, *Id) (*NodeAndHopInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindSuccessor not implemented")
}
func (UnimplementedNodeServer) FindPredecessor(context.Context, *Id) (*NodeAndHopInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method FindPredecessor not implemented")
}
func (UnimplementedNodeServer) ClosestPrecedingFinger(context.Context, *Id) (*NodeInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method ClosestPrecedingFinger not implemented")
}
func (UnimplementedNodeServer) NotificationByPredecessor(context.Context, *NodeInfo) (*Void, error) {
	return nil, status.Errorf(codes.Unimplemented, "method NotificationByPredecessor not implemented")
}
func (UnimplementedNodeServer) NotificationBySuccessor(context.Context, *NodeInfo) (*Void, error) {
	return nil, status.Errorf(codes.Unimplemented, "method NotificationBySuccessor not implemented")
}
func (UnimplementedNodeServer) CheckNode(context.Context, *NodeInfo) (*Void, error) {
	return nil, status.Errorf(codes.Unimplemented, "method CheckNode not implemented")
}
func (UnimplementedNodeServer) SetReplicatedValue(context.Context, *IdAndValue) (*Void, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetReplicatedValue not implemented")
}
func (UnimplementedNodeServer) SetValue(context.Context, *IdAndValue) (*NodeAndHopInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method SetValue not implemented")
}
func (UnimplementedNodeServer) DelValue(context.Context, *Id) (*NodeAndHopInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method DelValue not implemented")
}
func (UnimplementedNodeServer) GetValue(context.Context, *Id) (*ValueInfo, error) {
	return nil, status.Errorf(codes.Unimplemented, "method GetValue not implemented")
}
func (UnimplementedNodeServer) mustEmbedUnimplementedNodeServer() {}

// UnsafeNodeServer may be embedded to opt out of forward compatibility for this service.
// Use of this interface is not recommended, as added methods to NodeServer will
// result in compilation errors.
type UnsafeNodeServer interface {
	mustEmbedUnimplementedNodeServer()
}

func RegisterNodeServer(s grpc.ServiceRegistrar, srv NodeServer) {
	s.RegisterService(&Node_ServiceDesc, srv)
}

func _Node_Successor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Void)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).Successor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_Successor_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).Successor(ctx, req.(*Void))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_Predecessor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Void)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).Predecessor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_Predecessor_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).Predecessor(ctx, req.(*Void))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_FindSuccessor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Id)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).FindSuccessor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_FindSuccessor_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).FindSuccessor(ctx, req.(*Id))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_FindPredecessor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Id)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).FindPredecessor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_FindPredecessor_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).FindPredecessor(ctx, req.(*Id))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_ClosestPrecedingFinger_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Id)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).ClosestPrecedingFinger(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_ClosestPrecedingFinger_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).ClosestPrecedingFinger(ctx, req.(*Id))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_NotificationByPredecessor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(NodeInfo)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).NotificationByPredecessor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_NotificationByPredecessor_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).NotificationByPredecessor(ctx, req.(*NodeInfo))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_NotificationBySuccessor_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(NodeInfo)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).NotificationBySuccessor(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_NotificationBySuccessor_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).NotificationBySuccessor(ctx, req.(*NodeInfo))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_CheckNode_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(NodeInfo)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).CheckNode(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_CheckNode_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).CheckNode(ctx, req.(*NodeInfo))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_SetReplicatedValue_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(IdAndValue)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).SetReplicatedValue(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_SetReplicatedValue_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).SetReplicatedValue(ctx, req.(*IdAndValue))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_SetValue_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(IdAndValue)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).SetValue(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_SetValue_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).SetValue(ctx, req.(*IdAndValue))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_DelValue_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Id)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).DelValue(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_DelValue_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).DelValue(ctx, req.(*Id))
	}
	return interceptor(ctx, in, info, handler)
}

func _Node_GetValue_Handler(srv interface{}, ctx context.Context, dec func(interface{}) error, interceptor grpc.UnaryServerInterceptor) (interface{}, error) {
	in := new(Id)
	if err := dec(in); err != nil {
		return nil, err
	}
	if interceptor == nil {
		return srv.(NodeServer).GetValue(ctx, in)
	}
	info := &grpc.UnaryServerInfo{
		Server:     srv,
		FullMethod: Node_GetValue_FullMethodName,
	}
	handler := func(ctx context.Context, req interface{}) (interface{}, error) {
		return srv.(NodeServer).GetValue(ctx, req.(*Id))
	}
	return interceptor(ctx, in, info, handler)
}

// Node_ServiceDesc is the grpc.ServiceDesc for Node service.
// It's only intended for direct use with grpc.RegisterService,
// and not to be introspected or modified (even as a copy)
var Node_ServiceDesc = grpc.ServiceDesc{
	ServiceName: "chord.Node",
	HandlerType: (*NodeServer)(nil),
	Methods: []grpc.MethodDesc{
		{
			MethodName: "Successor",
			Handler:    _Node_Successor_Handler,
		},
		{
			MethodName: "Predecessor",
			Handler:    _Node_Predecessor_Handler,
		},
		{
			MethodName: "FindSuccessor",
			Handler:    _Node_FindSuccessor_Handler,
		},
		{
			MethodName: "FindPredecessor",
			Handler:    _Node_FindPredecessor_Handler,
		},
		{
			MethodName: "ClosestPrecedingFinger",
			Handler:    _Node_ClosestPrecedingFinger_Handler,
		},
		{
			MethodName: "NotificationByPredecessor",
			Handler:    _Node_NotificationByPredecessor_Handler,
		},
		{
			MethodName: "NotificationBySuccessor",
			Handler:    _Node_NotificationBySuccessor_Handler,
		},
		{
			MethodName: "CheckNode",
			Handler:    _Node_CheckNode_Handler,
		},
		{
			MethodName: "SetReplicatedValue",
			Handler:    _Node_SetReplicatedValue_Handler,
		},
		{
			MethodName: "SetValue",
			Handler:    _Node_SetValue_Handler,
		},
		{
			MethodName: "DelValue",
			Handler:    _Node_DelValue_Handler,
		},
		{
			MethodName: "GetValue",
			Handler:    _Node_GetValue_Handler,
		},
	},
	Streams:  []grpc.StreamDesc{},
	Metadata: "internal/pkg/chord/proto/node.proto",
}
